<template>
  <div v-if="buildingsAge && precipitation && slope && numberCemeteries && numberAgriBuildings && numberNonConnectedBuildings || surface" class="station-landuse">
    <div v-if="surface">
      <h2>Occupation du sol</h2>
      <h3>Proportion des surfaces</h3>
      <div class="landuse-surface">{{ surface }} ha</div>
      <div class="landuse-widget">
        <div :style="{
            width: `${agriShare}%`,
            backgroundColor: 'khaki'
          }">agricole</div>
        <div :style="{
            width: `${forestShare}%`,
            backgroundColor: 'SeaGreen'
          }"><span v-if="forestShare > 8" >forêts</span></div>
        <div :style="{
            width: `${builtShare}%`,
            backgroundColor: 'IndianRed '
          }"><span v-if="builtShare > 8" >bâti</span></div>
          autre
      </div>

      <h3>Partage de la surface agricole</h3>
      <div class="landuse-surface">{{ (surface * agriShare / 100).toFixed() }} ha</div>
      <div class="landuse-widget">
        <div :style="{
            width: `${cropShare / agriShare * 100}%`,
            backgroundColor: 'SandyBrown'
          }">cultures</div>
        <div :style="{
            width: `${meadowShare / agriShare * 100}%`,
            backgroundColor: 'YellowGreen'
          }">prairies</div>
      </div>
    </div>
    <div v-if="buildingsAge && precipitation && slope && numberCemeteries && numberAgriBuildings && numberNonConnectedBuildings">
      <h2>Autres informations</h2>
      <ul>
        <li v-if="buildingsAge">
          <i class="fa fa-building-o" aria-hidden="true"></i> {{ buildingsAge }} ans (âge moyen du bâti)
        </li>
        <li v-if="precipitation">
          <i class="fa fa-cloud" aria-hidden="true"></i> {{ precipitation }} mm (précipitations moyennes annuelles)
        </li>
        <li v-if="slope">
          {{ slope }} % (pente moyenne)
        </li>
        <li v-if="numberCemeteries">
          {{ numberCemeteries }} cimetières
        </li>
        <li v-if="numberAgriBuildings">
          {{ numberAgriBuildings }} bâtiments agricoles
        </li>
        <li v-if="numberNonConnectedBuildings">
          {{ numberNonConnectedBuildings }} bâtiments non connectés aux égouts.
        </li>
      </ul>
    </div>
  </div>
  <div v-else>
    Pas d'informations
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { StationLandUse } from '../api';
import { useStore } from '../store';


export default defineComponent({
  name: 'StationLandUseContent',
  setup: () => {
    const store = useStore();

    const getStationLandUseInfo = (): StationLandUse | undefined =>
      store.state.stationsLandUse.find((s: StationLandUse) => s.station === store.state.selectedStationId);

    const buildingsAge = getStationLandUseInfo()?.buildingsAge.toFixed();
    const precipitation = getStationLandUseInfo()?.precipitation.toFixed();
    const slope = getStationLandUseInfo()?.slope.toFixed();
    const numberCemeteries =
      getStationLandUseInfo()?.numberCemeteries === 0
        ? 'Pas de '
        : getStationLandUseInfo()?.numberCemeteries.toFixed();
    const numberAgriBuildings =
      getStationLandUseInfo()?.numberAgriBuildings === 0
        ? 'Pas de '
        : getStationLandUseInfo()?.numberAgriBuildings.toFixed()
    const numberNonConnectedBuildings = getStationLandUseInfo()?.numberNonConnectedBuildings;

    const surface = Math.round(getStationLandUseInfo()?.surfaceZone ?? 0);
    const agriShare = Math.round(getStationLandUseInfo()?.agriShare ?? 0);
    const forestShare = Math.round(getStationLandUseInfo()?.forestShare ?? 0);
    const cropShare = Math.round(getStationLandUseInfo()?.cropShare ?? 0);
    const meadowShare = Math.round(getStationLandUseInfo()?.meadowShare ?? 0);
    const builtShare = Math.round(getStationLandUseInfo()?.builtShare ?? 0);

    return {
      store,
      surface,
      agriShare,
      cropShare,
      meadowShare,
      forestShare,
      builtShare,
      buildingsAge,
      precipitation,
      slope,
      numberCemeteries,
      numberAgriBuildings,
      numberNonConnectedBuildings,
    }
  }
})
</script>


<style lang="scss" scoped>

div.landuse-surface {
  display: flex;
  justify-content: flex-end;
}

div.landuse-widget {
  display: flex;
  width: 400px;
  height: 25px;
  background-color: grey;
  &.div {
    height: inherit;
  }
}
</style>
